// http://www.sunsetlakesoftware.com/2013/10/21/optimizing-gaussian-blurs-mobile-gpu

attribute vec4 a_position;
attribute vec4 a_color;
attribute vec2 a_texCoord;

uniform vec2 texelWidthOffset;
uniform vec4 clampCoordinate;

varying vec2 blurCoordinates[5];
varying vec4 v_fragmentColor;

void main()
{
    gl_Position = CC_PMatrix * a_position;
    v_fragmentColor = a_color;

    blurCoordinates[0] = a_texCoord.xy;
    blurCoordinates[1] = clamp(a_texCoord.xy + texelWidthOffset * 1.407333, clampCoordinate.xy, clampCoordinate.zw);
    blurCoordinates[2] = clamp(a_texCoord.xy - texelWidthOffset * 1.407333, clampCoordinate.xy, clampCoordinate.zw);
    blurCoordinates[3] = clamp(a_texCoord.xy + texelWidthOffset * 3.294215, clampCoordinate.xy, clampCoordinate.zw);
    blurCoordinates[4] = clamp(a_texCoord.xy - texelWidthOffset * 3.294215, clampCoordinate.xy, clampCoordinate.zw);
}
