varying vec4 v_fragmentColor;
varying vec2 v_texCoord;

uniform sampler2D u_normal;
uniform sampler2D u_lut;
uniform sampler2D u_character;

uniform float u_enable;
varying vec2 v_lightPos;

void main()
{
    float characterAlpha    = texture2D(u_character, v_texCoord).a;

    // LightPos
    vec3 lightPos = vec3(v_lightPos, 0.1);

    // ToLightPos
    vec3 toLightVec = lightPos - vec3(v_texCoord, 0.0);
    toLightVec = normalize(toLightVec);

    // normal
    vec3 normal = vec3((texture2D(u_normal, fract(v_texCoord * 2.0)).rg - vec2(0.5)) * 2.0, 1.0);
    normal = normalize(normal);

    // CalcColor
    float p = abs(dot(toLightVec, normal));
    vec2 lutUV = vec2(0.5, fract(p));
    vec3 lutColor = texture2D(u_lut, lutUV).rgb * p;
    lutColor *= 1.2;

    vec4 baseColor = v_fragmentColor * texture2D(CC_Texture0, v_texCoord);
    
    baseColor.rgb += lutColor * u_enable;

    gl_FragColor = vec4(baseColor.rgb * baseColor.a, baseColor.a);
}
